Intel® Enhanced Privacy ID SDK 2.0.0

Data Structures | Enumerations | Functions | Variables
fileparser
epid » common

Parser for issuer material. More...

## Data Structures
struct | EpidFileHeader
| Intel(R) EPID binary file header. More...
struct | EpidCaCertificate
| IoT CA Certificate binary format. More...

## Enumerations
enum | EpidFileType { kIssuingCaPubKeyFile, kGroupPubKeyFile, kPrivRlFile, kSigRlFile, kGroupRlFile, kPrivRlRequestFile, kSigRlRequestFile, kGroupRlRequestFile, kNumFileTypes }
| Recognized Intel(R) EPID file types. More...

## Functions
EpidStatus | EpidParseGroupPubKeyFile (void const *buf, size_t len, EpidCaCertificate const *cert, GroupPubKey *pubkey)
| Extracts group public key from buffer in issuer binary format. More...
EpidStatus | EpidParsePrivRlFile (void const *buf, size_t len, EpidCaCertificate const *cert, PrivRl *rl, size_t *rl_len)
| Extracts private key revocation list from buffer in issuer binary format. More...
EpidStatus | EpidParseSigRlFile (void const *buf, size_t len, EpidCaCertificate const *cert, SigRl *rl, size_t *rl_len)
| Extracts signature revocation list from buffer in issuer binary format. More...
EpidStatus | EpidParseGroupRlFile (void const *buf, size_t len, EpidCaCertificate const *cert, GroupRl *rl, size_t *rl_len)
| Extracts group revocation list from buffer in issuer binary format. More...

## Variables
const OctStr16 | kEpidFileTypeCode [kNumFileTypes]
| Encoding of issuer material file types.

## Detailed Description

Parser for issuer material.

Provides an API for parsing buffers formatted according to the various IoT Intel(R) EPID binary file formats.

## Enumeration Type Documentation

enum EpidFileType

Recognized Intel(R) EPID file types.

Enumerator
kIssuingCaPubKeyFile | IoT Issuing CA public key file.
kGroupPubKeyFile | Group Public Key Output File Format.
kPrivRlFile | Binary Private Key Revocation List.
kSigRlFile | Binary Signature Revocation List.
kGroupRlFile | Binary Group Revocation List.
kPrivRlRequestFile | Binary Private Key Revocation Request.
kSigRlRequestFile | Binary Signature Revocation Request.
kGroupRlRequestFile | Binary Group Revocation Request.
kNumFileTypes | Maximum number of file types.

## Function Documentation

EpidStatus EpidParseGroupPubKeyFile | ( | void const * | buf,
|  | size_t | len,
|  | EpidCaCertificate const * | cert,
|  | GroupPubKey * | pubkey
| ) |  |

Extracts group public key from buffer in issuer binary format.

Extracts the first group public key from a buffer with format of Intel(R) EPID 2.0 Group Public Key Certificate Binary File. The function validates that the first public key was signed by the private key corresponding to the provided CA certificate and the size of the input buffer is correct.

Warning
  It is the responsibility of the caller to authenticate the EpidCaCertificate.

Parameters

  [in] | buf | Pointer to buffer containing public key to extract.
  [in] | len | The size of buf in bytes.
  [in] | cert | The issuing CA public key certificate.
  [out] | pubkey | The extracted group public key.

Returns
  EpidStatus

Return values

  kEpidSigInvalid | Parsing failed due to data authentication failure.

EpidStatus EpidParseGroupRlFile | ( | void const * | buf,
|  | size_t | len,
|  | EpidCaCertificate const * | cert,
|  | GroupRl * | rl,
|  | size_t * | rl_len
| ) |  |

Extracts group revocation list from buffer in issuer binary format.

Extracts the group revocation list from a buffer with format of Binary Group Certificate Revocation List File. The function validates that the revocation list was signed by the private key corresponding to the provided CA certificate and the size of the input buffer is correct.

To determine the required size of the revocation list output buffer, provide a null pointer for the output buffer.

Warning
  It is the responsibility of the caller to authenticate the EpidCaCertificate.

Parameters

  [in] | buf | Pointer to buffer containing the revocation list to extract.
  [in] | len | The size of buf in bytes.
  [in] | cert | The issuing CA public key certificate.
  [out] | rl | The extracted revocation list. If Null, rl_len is filled with the required output buffer size.
  [in,out] | rl_len | The size of rl in bytes.

Returns
  EpidStatus

Return values

  kEpidSigInvalid | Parsing failed due to data authentication failure.

EpidStatus EpidParsePrivRlFile | ( | void const * | buf,
|  | size_t | len,
|  | EpidCaCertificate const * | cert,
|  | PrivRl * | rl,
|  | size_t * | rl_len
| ) |  |

Extracts private key revocation list from buffer in issuer binary format.

Extracts the private key revocation list from a buffer with format of Binary Private Key Revocation List File. The function validates that the revocation list was signed by the private key corresponding to the provided CA certificate and the size of the input buffer is correct.

To determine the required size of the revocation list output buffer, provide a null pointer for the output buffer.

Warning
  It is the responsibility of the caller to authenticate the EpidCaCertificate.

Parameters

  [in] | buf | Pointer to buffer containing the revocation list to extract.
  [in] | len | The size of buf in bytes.
  [in] | cert | The issuing CA public key certificate.
  [out] | rl | The extracted revocation list. If Null, rl_len is filled with the required output buffer size.
  [in,out] | rl_len | The size of rl in bytes.

Returns
  EpidStatus

Return values

  kEpidSigInvalid | Parsing failed due to data authentication failure.

EpidStatus EpidParseSigRlFile | ( | void const * | buf,
|  | size_t | len,
|  | EpidCaCertificate const * | cert,
|  | SigRl * | rl,
|  | size_t * | rl_len
| ) |  |

Extracts signature revocation list from buffer in issuer binary format.

Extracts the signature based revocation list from a buffer with format of Binary Signature Revocation List File. The function validates that the revocation list was signed by the private key corresponding to the provided CA certificate and the size of the input buffer is correct.

To determine the required size of the revocation list output buffer, provide a null pointer for the output buffer.

Warning
  It is the responsibility of the caller to authenticate the EpidCaCertificate.

Parameters

  [in] | buf | Pointer to buffer containing the revocation list to extract.
  [in] | len | The size of buf in bytes.
  [in] | cert | The issuing CA public key certificate.
  [out] | rl | The extracted revocation list. If Null, rl_len is filled with the required output buffer size.
  [in,out] | rl_len | The size of rl in bytes.

Returns
  EpidStatus

Return values

  kEpidSigInvalid | Parsing failed due to data authentication failure.